// author: Scott Grayban
// contact: sgrayban@gmail.com
// Version 1.0
//
//		Common (global) variables

// Get pointer to preferences
	try{
		var oPrefs = Components.classes["@mozilla.org/preferences-service;1"]
					.getService(Components.interfaces.nsIPrefService).getBranch("");
	}catch(e){alert(e);}
	
	var FFCUBnsISupportsString = Components.interfaces.nsISupportsString;
	var FFCUB_GUID = "clearurlbutton@blog.borgnet.us"  // GUID of this extension

function ffcubLoad(){
	ffcubSetMsgs();
}//ffcubLoad()

function ffcubInit(){
	ffcubVersion = ffcubMsg[01]+" "+getFFcubVersion();
	return true;
}//ffcubInit()

function ffcubGetUnicharPref(prefName) {
    return oPrefs.getComplexValue(prefName, FFcubnsISupportsString).data;
}

function ffcubExtInfo(extGuid){

  // Get extension info from extensions.rdf

    var rdfs = Components.classes["@mozilla.org/rdf/rdf-service;1"]
                       .getService(Components.interfaces.nsIRDFService);
                     
	var profileDir = Components.classes["@mozilla.org/file/directory_service;1"]
        .getService(Components.interfaces.nsIProperties)
        .get("ProfD", Components.interfaces.nsIFile);
	profileDir.append("extensions.rdf");
	
	// Fix for international characters
	var ioServ = Components.classes["@mozilla.org/network/io-service;1"]
                          .getService(Components.interfaces.nsIIOService);
	var fph = ioServ.getProtocolHandler("file").QueryInterface(Components.interfaces.nsIFileProtocolHandler);
	var srcFile = fph.getURLSpecFromFile(profileDir);
	
	var ds = rdfs.GetDataSourceBlocking(srcFile);
	
	// Use old method if something comes up undefined
	var em = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
	var ext = null;
	if (em.getItemForID){
		ext = em.getItemForID(extGUID);
	}else{
		ext = em.getItemList(extGUID, null, {})[0];
	}//if
	
	var subject = rdfs.GetResource("urn:mozilla:item:"+extGuid);
	var prefix = "http://www.mozilla.org/2004/em-rdf#";
	
  // Guid
	this.guid = extGuid;
	
  // Name
	var predicate = rdfs.GetResource(prefix + "name");
	var name = ds.GetTarget(subject, predicate, true);
	if(name){
		this.name = name.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
	}else{
		this.name = ext.name;
	}//if
	if(!this.name){this.name="(none)";}
	
  // Version
	var predicate = rdfs.GetResource(prefix + "version");
	var version = ds.GetTarget(subject, predicate, true);
	if(version){
		this.version = version.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
	}else{
		this.version = ext.version;
	}//if
	if(!this.version){this.version="(none)";}

  // Description
	var predicate = rdfs.GetResource(prefix + "description");
	var description = ds.GetTarget(subject, predicate, true);
	if(description){this.description = description.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;}
	if(!this.description){this.description="(none)";}

  // Home Page URL
	var predicate = rdfs.GetResource(prefix + "homepageURL");
	var homepageURL = ds.GetTarget(subject, predicate, true);
	if(homepageURL){this.homepageURL = homepageURL.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;}

  // Creator
	var predicate = rdfs.GetResource(prefix + "creator");
	var creator = ds.GetTarget(subject, predicate, true);
	if(creator){this.creator = creator.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;}
	if(!this.creator){this.creator="(none)";}

  // Disabled?
	var predicate = rdfs.GetResource(prefix + "userDisabled");
	var userDisabled = ds.GetTarget(subject, predicate, true);
	if(userDisabled){
		this.isDisabled = userDisabled.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
	}else{
		this.isDisabled = false;
	}//if

  // iconURL
	var predicate = rdfs.GetResource(prefix + "iconURL");
	var iconURL = ds.GetTarget(subject, predicate, true);
	if(iconURL){
		this.iconURL = iconURL.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
	}else{
		this.iconURL = ext.iconURL;
	}//if
	if(!this.iconURL){this.iconURL="chrome://mozapps/skin/xpinstall/xpinstallItemGeneric.png";}
	
  // minVersion
	this.minVersion = ext.minAppVersion;
	if(!this.minVersion){this.minVersion="(none)";}
	
  // maxVersion    
	this.maxVersion = ext.maxAppVersion;
	if(!this.maxVersion){this.maxVersion="(none)";}
	
  // installLocation
	var predicate = rdfs.GetResource(prefix + "installLocation");
	var installLocation = ds.GetTarget(subject, predicate, true);
	if(installLocation){this.installLocation = installLocation.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;}
	if(!this.installLocation){this.installLocation="(none)";}
	
  // parseType
	var predicate = rdfs.GetResource(prefix + "type");
	var parseType = ds.GetTarget(subject, predicate, true);
	if(parseType){
		this.type = parseType.QueryInterface(Components.interfaces.nsIRDFInt).Value;
	}else{
		this.type = ext.type;
	}//if

  // internalName
	var predicate = rdfs.GetResource(prefix + "internalName");
	var internalName = ds.GetTarget(subject, predicate, true);
	if(internalName){this.internalName = internalName.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;}
	if(!this.internalName){this.internalName="(none)";}
	
  // updateURL
	var predicate = rdfs.GetResource(prefix + "updateURL");
	var updateURL = ds.GetTarget(subject, predicate, true);
	if(updateURL){this.updateURL = updateURL.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;}
	if(!this.updateURL){this.updateURL="(none)";}
	
  // optionsURL
	var predicate = rdfs.GetResource(prefix + "optionsURL");
	var optionsURL = ds.GetTarget(subject, predicate, true);
	if(optionsURL){this.optionsURL = optionsURL.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;}
	if(!this.optionsURL){this.optionsURL="(none)";}
	
  // aboutURL
	var predicate = rdfs.GetResource(prefix + "aboutURL");
	var aboutURL = ds.GetTarget(subject, predicate, true);
	if(aboutURL){this.aboutURL = aboutURL.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;}
	if(!this.aboutURL){this.aboutURL="(none)";}
	
  // availableUpdateURL
	var predicate = rdfs.GetResource(prefix + "availableUpdateURL");
	var availableUpdateURL = ds.GetTarget(subject, predicate, true);
	if(availableUpdateURL){this.availableUpdateURL = availableUpdateURL.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;}
	if(!this.availableUpdateURL){this.availableUpdateURL="(none)";}
	
  // availableUpdateHash
	var predicate = rdfs.GetResource(prefix + "availableUpdateHash");
	var availableUpdateHash = ds.GetTarget(subject, predicate, true);
	if(availableUpdateHash){this.availableUpdateHash = availableUpdateHash.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;}
	if(!this.availableUpdateHash){this.availableUpdateHash="(none)";}
	
  // availableUpdateVersion
	var predicate = rdfs.GetResource(prefix + "availableUpdateVersion");
	var availableUpdateVersion = ds.GetTarget(subject, predicate, true);
	if(availableUpdateVersion){this.availableUpdateVersion = availableUpdateVersion.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;}
	if(!this.availableUpdateVersion){this.availableUpdateVersion="(none)";}
	
  // contributors
	var predicate = rdfs.GetResource(prefix + "contributor");
	var targets = ds.GetTargets(subject, predicate, true);
	var contributors = [];
	if(targets){
		while (targets.hasMoreElements()){
			var contributor = targets.getNext();
			if (contributor instanceof Components.interfaces.nsIRDFLiteral){
				contributors.push(contributor.Value);
			}//if
		}//while
		this.contributors = contributors;
	}//if
}//ffcubExtInfo()

function ffcubSetUnicharPref(prefName, prefValue) {
    var supportsString = Components.classes["@mozilla.org/supports-string;1"].createInstance(FFcubnsISupportsString);
    supportsString.data = prefValue;
    oPrefs.setComplexValue(prefName, FFcubnsISupportsString, supportsString);

}

window.addEventListener("load",ffcubSetMsgs,true);

// Set global variables
        var ffcubMsg = [];				// Array holding localized strings
	var ffcubVersion = new String();		// Version of this extension (FEBE)
	var ffcubInitialized = new Boolean(false);	// Initalize function run yet?

function ffcubSetMsgs(){
  // Error messages, prompts, etc.
        var fs = document.getElementById('clearurlbutton-strings');
        ffcubMsg.push(fs.getString("msg01"));    // "Version"

}//ffcubSetMsgs()

function ffcubExtObj(Name, Path, Icon, Home, guid, verified){
	this.Name = new String(Name);
	this.Path = new String(Path); 
	this.Icon = new String(Icon); 
	this.Home = new String(Home); 
	this.guid = new String(guid); 
	this.verified = new Boolean(verified);
}//ffcubExtObj

function getFFcubVersion() {
	var em = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
	var ext = null;
	if (em.getItemForID){
		ext = em.getItemForID(FFCUB_GUID);
	}else{
		ext = em.getItemList(FFCUB_GUID, null, {})[0];
	}//if
	return ext.version;
}//getFFcubVersion()

function setFFcubVersion(){
	ffcubSetMsgs();
	var version = getFFcubVersion();
	document.getElementById("FFcubVersionID").value = ffcubMsg[01]+" "+version;
	return;
}//setFFcubVersion()

function ffcubOpenLink(URL){
	// Thanks to menet for providing the code to display the results page in an unused tab
	// if one is availble.
	if(!URL){return;}
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
           .getService(Components.interfaces.nsIWindowMediator);
	var win = wm.getMostRecentWindow("navigator:browser");
	var ffcubGetBrowser = win.getBrowser();
	var currBlank = (ffcubGetBrowser &&
	(ffcubGetBrowser.mCurrentTab.linkedBrowser &&
	(ffcubGetBrowser.mCurrentTab.linkedBrowser.contentDocument.location == "about:blank")) ||
	(!ffcubGetBrowser.mCurrentTab.linkedBrowser &&
	(ffcubGetBrowser.mCurrentTab.label == "(Untitled)")));
	if (currBlank)
		{
			var resultsWindow = win.loadURI(URL);
		} else {
			var resultsWindow = win.openNewTabWith(URL, this.docURL, null, null);
    }//if
}//ffcubOpenLink()
